unit PongUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, NiceGrid, Math;

type
  TForm1 = class(TForm)
    NiceGrid1: TNiceGrid;
    btClear: TButton;
    btCalc: TButton;
    btSvLed: TButton;
    SaveDialog1: TSaveDialog;
    btSvTxt: TButton;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    btLoad: TButton;
    OpenDialog1: TOpenDialog;
    procedure btClearClick(Sender: TObject);
    procedure btCalcClick(Sender: TObject);
    procedure NiceGrid1DrawCell(Sender: TObject; ACanvas: TCanvas; X,
      Y: Integer; Rc: TRect; var Handled: Boolean);
    procedure btSvLedClick(Sender: TObject);
    procedure btSvTxtClick(Sender: TObject);
    procedure btLoadClick(Sender: TObject);
  private
    { Private declarations }
  public
    cnt: array[0..12] of word;
    sbin: array[0..12] of string[12];
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
function sBreakApart(BaseString, BreakString: string; StringList: TStringList): TStringList;
var
  EndOfCurrentString: byte;

  TempStr: string;
begin
  repeat
    EndOfCurrentString := Pos(BreakString, BaseString);
    if EndOfCurrentString = 0 then
      StringList.add(BaseString)
    else
      StringList.add(Copy(BaseString, 1, EndOfCurrentString - 1));
    BaseString := Copy(BaseString, EndOfCurrentString + length(BreakString), length(BaseString) - EndOfCurrentString);
  until EndOfCurrentString = 0;
  result := StringList;
end;


procedure TForm1.btClearClick(Sender: TObject);
begin
   NiceGrid1.Clear;
end;

procedure TForm1.btCalcClick(Sender: TObject);
var i,j  : word;
begin
     for j := 0 to NiceGrid1.ColCount -1 do
      begin
        cnt[j] :=0; //clear
        NiceGrid1.Cells[j,10] := '0';
        sbin[j] := '';
     end;
     for j := 0 to NiceGrid1.ColCount -1 do
     begin
      for i := NiceGrid1.RowCount -2 downto 0 do
       begin
         if (NiceGrid1.Cells[j,i] <> '') then begin
         sbin[j] := sbin[j] + '1';   //binary
        end // if
        else sbin[j] := sbin[j] + '0';
       end;  // for i
      end;  // for j
     for j := 0 to NiceGrid1.ColCount -1 do
     begin
      cnt[j] :=0;
      for i := 0 to NiceGrid1.RowCount -2 do
       begin
         if (NiceGrid1.Cells[j,i] <> '') then begin
            cnt[j] := cnt[j]+ round(power(2,i));
         end; // if
       end;  // for i
       NiceGrid1.Cells[j,10] := FormatFloat('0',cnt[j]);
      end;  // for j
      btSvLed.Enabled:=true;
      btSvTxt.Enabled:=true;
end;
     
procedure TForm1.NiceGrid1DrawCell(Sender: TObject; ACanvas: TCanvas; X,
  Y: Integer; Rc: TRect; var Handled: Boolean);
var
  i: Integer;
begin
  i := StrToIntDef(NiceGrid1.Cells[X, Y], 0);
  if ((i mod 2) = 0)
    then ACanvas.Brush.Color := clYellow
    else ACanvas.Brush.Color := $00CAFFFF;
  if Odd(i) and (Y<10)
    then begin
     ACanvas.Font.Color := clBlack;
     ACanvas.Brush.Color := clRed;
    end;
end;

procedure TForm1.btSvLedClick(Sender: TObject);
var i : Integer;
    S : String;
    F: TextFile;
begin
  SaveDialog1.FileName := SaveDialog1.InitialDir+'Leds.txt';
  if SaveDialog1.Execute then begin
    AssignFile(F, SaveDialog1.FileName);   { File selected in dialog box }
    Rewrite(F);
    for i := 0 to NiceGrid1.ColCount -1 do begin
       S := 'Leds('+InttoStr(i+1)+')='+ FormatFloat('0',cnt[i]);
       Writeln(F, S );
    end;
    CloseFile(F);
  end;
end;

procedure TForm1.btSvTxtClick(Sender: TObject);
var i,n : Integer;
    S,s1 : String;
    F: TextFile;
begin
  S:='';
  btCalcClick(nil);
  if RadioButton1.checked then begin
   for i := 0 to NiceGrid1.ColCount -1 do begin  //dec
       S := S+ FormatFloat('0',cnt[i])+',';
   end;
   SaveDialog1.FileName := SaveDialog1.InitialDir+'Leddec.txt';
  end; //RadioButton1
  if RadioButton2.checked then begin
   for i := 0 to NiceGrid1.ColCount -1 do begin  //hex
       s1 := FormatFloat('0',cnt[i]);
       n:= StrtoInt(s1);
       S := S+ InttoHex(n,1)+',';
   end;
   SaveDialog1.FileName := SaveDialog1.InitialDir+'Ledhex.txt';
  end; //  if RadioButton2
  if RadioButton3.checked then begin
   for i := 0 to NiceGrid1.ColCount -1 do begin  //bin
        S := S+ sbin[i]+',';
   end;
   SaveDialog1.FileName := SaveDialog1.InitialDir+'Ledbin.txt';
  end; //if RadioButton3
  if SaveDialog1.Execute then begin
    AssignFile(F, SaveDialog1.FileName);   { File selected in dialog box }
    Rewrite(F);
    Writeln(F, S );
    CloseFile(F);
  end;
end;

procedure TForm1.btLoadClick(Sender: TObject);
var i,j,n,k,x : word;
    S,s1 : String;
    F: TextFile;
    t: Tstringlist;
begin
  if OpenDialog1.Execute then begin
    AssignFile(F, OpenDialog1.FileName);   { File selected in dialog box }
    Reset(F);
    Readln(F, S );
    CloseFile(F);
    NiceGrid1.Clear;
    t:= Tstringlist.Create;
    sBreakApart(S, ',', t);
    for i := 0 to t.Count - 2 do  begin
      cnt[i] := StrtoInt(t[i]);
      NiceGrid1.Cells[i,10] := t[i];
    end; //for
    t.free;

    for j := 0 to NiceGrid1.ColCount -1 do begin
     x:= cnt[j];
     for i := NiceGrid1.RowCount -2 downto 0 do
       begin
         n:= round(power(2,i));
         k:= x div n;
         if k > 0 then begin
            x:=x-n;
            NiceGrid1.Cells[j,i] := '1';
         end;
       end;  // for i
     end; // for j
  end;

end;

end.
